<?php
/* Autor...:  */
/* Esquema.: PLA_Asistencia.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Metodos de acceso a los campos de la tabla PLA_Asistencia */
abstract class BasePLA_AsistenciaBN
{
    /* Campos de la tabla */
    private $i_IdAsistencia;    // IdAsistencia: ( no definido )
    private $i_IdDiaSem;    // IdDiaSem: ( no definido )
    private $s_IdRegistro;    // IdRegistro: ( no definido )
    private $s_IdTipo;    // IdTipo: ( no definido )
    private $i_IdPersona;    // IdPersona: ( no definido )
    private $d_Fecha;    // Fecha: ( no definido )
    private $s_TipoDocumento;    // TipoDocumento: ( no definido )
    private $s_NumeroDocumento;    // NumeroDocumento: ( no definido )
    private $d_HoraMinuto;    // HoraMinuto: ( no definido )
    private $d_HoraMinutoPactado;    // HoraMinutoPactado: ( no definido )
    private $f_MontoDescuento;    // MontoDescuento: ( no definido )
    private $i_IdAsistenciaRef;    // IdAsistenciaRef: ( no definido )
    private $i_DiaSiguienteFlag;    // DiaSiguienteFlag: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $i_Eliminado;    // Eliminado: ( no definido )
    private $s_MotivoEliminado;    // MotivoEliminado: ( no definido )
    private $d_FechaEliminado;    // FechaEliminado: ( no definido )
    private $s_UsuarioEliminado;    // UsuarioEliminado: ( no definido )

    /* Establece el valor del campo IdAsistencia */
    public function setIdAsistencia( $i_IdAsistencia )
    {
        $this->i_IdAsistencia = $i_IdAsistencia;
    }

    /* Obtiene el valor del campo IdAsistencia */
    public function getIdAsistencia()
    {
        return $this->i_IdAsistencia;
    }

    /* Establece el valor del campo IdDiaSem */
    public function setIdDiaSem( $i_IdDiaSem )
    {
        $this->i_IdDiaSem = $i_IdDiaSem;
    }

    /* Obtiene el valor del campo IdDiaSem */
    public function getIdDiaSem()
    {
        return $this->i_IdDiaSem;
    }

    /* Establece el valor del campo IdRegistro */
    public function setIdRegistro( $s_IdRegistro )
    {
        $this->s_IdRegistro = $s_IdRegistro;
    }

    /* Obtiene el valor del campo IdRegistro */
    public function getIdRegistro()
    {
        return $this->s_IdRegistro;
    }

    /* Establece el valor del campo IdTipo */
    public function setIdTipo( $s_IdTipo )
    {
        $this->s_IdTipo = $s_IdTipo;
    }

    /* Obtiene el valor del campo IdTipo */
    public function getIdTipo()
    {
        return $this->s_IdTipo;
    }

    /* Establece el valor del campo IdPersona */
    public function setIdPersona( $i_IdPersona )
    {
        $this->i_IdPersona = $i_IdPersona;
    }

    /* Obtiene el valor del campo IdPersona */
    public function getIdPersona()
    {
        return $this->i_IdPersona;
    }

    /* Establece el valor del campo Fecha */
    public function setFecha( $d_Fecha )
    {
        $this->d_Fecha = $d_Fecha;
    }

    /* Obtiene el valor del campo Fecha */
    public function getFecha()
    {
        return $this->d_Fecha;
    }

    /* Establece el valor del campo TipoDocumento */
    public function setTipoDocumento( $s_TipoDocumento )
    {
        $this->s_TipoDocumento = $s_TipoDocumento;
    }

    /* Obtiene el valor del campo TipoDocumento */
    public function getTipoDocumento()
    {
        return $this->s_TipoDocumento;
    }

    /* Establece el valor del campo NumeroDocumento */
    public function setNumeroDocumento( $s_NumeroDocumento )
    {
        $this->s_NumeroDocumento = $s_NumeroDocumento;
    }

    /* Obtiene el valor del campo NumeroDocumento */
    public function getNumeroDocumento()
    {
        return $this->s_NumeroDocumento;
    }

    /* Establece el valor del campo HoraMinuto */
    public function setHoraMinuto( $d_HoraMinuto )
    {
        $this->d_HoraMinuto = $d_HoraMinuto;
    }

    /* Obtiene el valor del campo HoraMinuto */
    public function getHoraMinuto()
    {
        return $this->d_HoraMinuto;
    }

    /* Establece el valor del campo HoraMinutoPactado */
    public function setHoraMinutoPactado( $d_HoraMinutoPactado )
    {
        $this->d_HoraMinutoPactado = $d_HoraMinutoPactado;
    }

    /* Obtiene el valor del campo HoraMinutoPactado */
    public function getHoraMinutoPactado()
    {
        return $this->d_HoraMinutoPactado;
    }

    /* Establece el valor del campo MontoDescuento */
    public function setMontoDescuento( $f_MontoDescuento )
    {
        $this->f_MontoDescuento = $f_MontoDescuento;
    }

    /* Obtiene el valor del campo MontoDescuento */
    public function getMontoDescuento()
    {
        return $this->f_MontoDescuento;
    }

    /* Establece el valor del campo IdAsistenciaRef */
    public function setIdAsistenciaRef( $i_IdAsistenciaRef )
    {
        $this->i_IdAsistenciaRef = $i_IdAsistenciaRef;
    }

    /* Obtiene el valor del campo IdAsistenciaRef */
    public function getIdAsistenciaRef()
    {
        return $this->i_IdAsistenciaRef;
    }

    /* Establece el valor del campo DiaSiguienteFlag */
    public function setDiaSiguienteFlag( $i_DiaSiguienteFlag )
    {
        $this->i_DiaSiguienteFlag = $i_DiaSiguienteFlag;
    }

    /* Obtiene el valor del campo DiaSiguienteFlag */
    public function getDiaSiguienteFlag()
    {
        return $this->i_DiaSiguienteFlag;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo Eliminado */
    public function setEliminado( $i_Eliminado )
    {
        $this->i_Eliminado = $i_Eliminado;
    }

    /* Obtiene el valor del campo Eliminado */
    public function getEliminado()
    {
        return $this->i_Eliminado;
    }

    /* Establece el valor del campo MotivoEliminado */
    public function setMotivoEliminado( $s_MotivoEliminado )
    {
        $this->s_MotivoEliminado = $s_MotivoEliminado;
    }

    /* Obtiene el valor del campo MotivoEliminado */
    public function getMotivoEliminado()
    {
        return $this->s_MotivoEliminado;
    }

    /* Establece el valor del campo FechaEliminado */
    public function setFechaEliminado( $d_FechaEliminado )
    {
        $this->d_FechaEliminado = $d_FechaEliminado;
    }

    /* Obtiene el valor del campo FechaEliminado */
    public function getFechaEliminado()
    {
        return $this->d_FechaEliminado;
    }

    /* Establece el valor del campo UsuarioEliminado */
    public function setUsuarioEliminado( $s_UsuarioEliminado )
    {
        $this->s_UsuarioEliminado = $s_UsuarioEliminado;
    }

    /* Obtiene el valor del campo UsuarioEliminado */
    public function getUsuarioEliminado()
    {
        return $this->s_UsuarioEliminado;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdAsistencia' => $this->getIdAsistencia(),
            'IdDiaSem' => $this->getIdDiaSem(),
            'IdRegistro' => $this->getIdRegistro(),
            'IdTipo' => $this->getIdTipo(),
            'IdPersona' => $this->getIdPersona(),
            'Fecha' => $this->getFecha(),
            'TipoDocumento' => $this->getTipoDocumento(),
            'NumeroDocumento' => $this->getNumeroDocumento(),
            'HoraMinuto' => $this->getHoraMinuto(),
            'HoraMinutoPactado' => $this->getHoraMinutoPactado(),
            'MontoDescuento' => $this->getMontoDescuento(),
            'IdAsistenciaRef' => $this->getIdAsistenciaRef(),
            'DiaSiguienteFlag' => $this->getDiaSiguienteFlag(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'Eliminado' => $this->getEliminado(),
            'MotivoEliminado' => $this->getMotivoEliminado(),
            'FechaEliminado' => $this->getFechaEliminado(),
            'UsuarioEliminado' => $this->getUsuarioEliminado(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto PLA_AsistenciaBN desde un RecordSet */
    public static function retrieveByRs( $o_PLA_AsistenciaRs )
    {
        $o_PLA_AsistenciaBN = new PLA_AsistenciaBN();
        $o_PLA_AsistenciaBN->setIdAsistencia( ( integer ) $o_PLA_AsistenciaRs[ "IdAsistencia" ] );
        $o_PLA_AsistenciaBN->setIdDiaSem( ( integer ) $o_PLA_AsistenciaRs[ "IdDiaSem" ] );
        $o_PLA_AsistenciaBN->setIdRegistro( $o_PLA_AsistenciaRs[ "IdRegistro" ] );
        $o_PLA_AsistenciaBN->setIdTipo( $o_PLA_AsistenciaRs[ "IdTipo" ] );
        $o_PLA_AsistenciaBN->setIdPersona( ( integer ) $o_PLA_AsistenciaRs[ "IdPersona" ] );
        $o_PLA_AsistenciaBN->setFecha( utilTimestamp::getTimestamp( $o_PLA_AsistenciaRs[ "Fecha" ], "Y-m-d" ) );
        $o_PLA_AsistenciaBN->setTipoDocumento( $o_PLA_AsistenciaRs[ "TipoDocumento" ] );
        $o_PLA_AsistenciaBN->setNumeroDocumento( $o_PLA_AsistenciaRs[ "NumeroDocumento" ] );
        $o_PLA_AsistenciaBN->setHoraMinuto( utilTimestamp::getTimestamp( $o_PLA_AsistenciaRs[ "HoraMinuto" ], "Y-m-d H:i:s" ) );
        $o_PLA_AsistenciaBN->setHoraMinutoPactado( utilTimestamp::getTimestamp( $o_PLA_AsistenciaRs[ "HoraMinutoPactado" ], "Y-m-d H:i:s" ) );
        $o_PLA_AsistenciaBN->setMontoDescuento( ( float ) $o_PLA_AsistenciaRs[ "MontoDescuento" ] );
        $o_PLA_AsistenciaBN->setIdAsistenciaRef( ( integer ) $o_PLA_AsistenciaRs[ "IdAsistenciaRef" ] );
        $o_PLA_AsistenciaBN->setDiaSiguienteFlag( ( integer ) $o_PLA_AsistenciaRs[ "DiaSiguienteFlag" ] );
        $o_PLA_AsistenciaBN->setUsuarioCreacion( $o_PLA_AsistenciaRs[ "UsuarioCreacion" ] );
        $o_PLA_AsistenciaBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_PLA_AsistenciaRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_PLA_AsistenciaBN->setUsuarioModificacion( $o_PLA_AsistenciaRs[ "UsuarioModificacion" ] );
        $o_PLA_AsistenciaBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_PLA_AsistenciaRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_PLA_AsistenciaBN->setEliminado( ( integer ) $o_PLA_AsistenciaRs[ "Eliminado" ] );
        $o_PLA_AsistenciaBN->setMotivoEliminado( $o_PLA_AsistenciaRs[ "MotivoEliminado" ] );
        $o_PLA_AsistenciaBN->setFechaEliminado( utilTimestamp::getTimestamp( $o_PLA_AsistenciaRs[ "FechaEliminado" ], "Y-m-d H:i:s" ) );
        $o_PLA_AsistenciaBN->setUsuarioEliminado( $o_PLA_AsistenciaRs[ "UsuarioEliminado" ] );
        return $o_PLA_AsistenciaBN;
    }
}
?>